<script lang="ts">
  import { onMount } from 'svelte';
  import { eventId, keycloak, team } from "@stores";
  import type { Team } from '@models/Team';
  import { Gql } from '@db';
  import { GetServiceNames, ServiceStatusQuery } from '@models/Service';
  import type { ScoreBoardServiceStatus, Check } from '@models/Service';
  import ServiceStatusElement from './ServiceStatusElement.svelte';
  import { Button, Dropdown, DropdownItem, DropdownMenu, DropdownToggle, Input, Popover, Table } from '@sveltestrap/sveltestrap';
  import Fa from 'svelte-fa';
  import {
    faArrowCircleDown,
    faArrowCircleUp,
    faCircleExclamation,
    faCircleQuestion,
    faCircleInfo,
    faGear,
    faEyeSlash,
  } from '@fortawesome/free-solid-svg-icons';
  import { type NullableEventRole } from '@auth/models';

  export let onHideTeam: (id: string) => void;
  export let visibleTeams;
  export let shortNames: boolean;

  let disposeScoresSocket;

  let scoreboardTeams: Array<Team> = Array<Team>();
  let serviceDisplayNames: Array<Partial<Check>> = Array<Partial<Check>>();
  let scoreBoardServiceStatus: Array<ScoreBoardServiceStatus>;
  $: scoreBoardServiceStatus = Array<ScoreBoardServiceStatus>();
  let queryRole: NullableEventRole;

  onMount(async () => {
    await initialize();
  });

  function getTeamsFromServiceStatuses() {
    const newScoreboardTeams = Array<Team>();
    const teamIds = {};
    for (let i = 0; i < scoreBoardServiceStatus.length; i++) {
      const team = scoreBoardServiceStatus[i].team;
      if (!(team.id in teamIds)) {
        newScoreboardTeams.push(team);
        teamIds[team.id] = true;
      }
    }

    return newScoreboardTeams;
  }

  async function initialize() {
    scoreBoardServiceStatus = (
      await Gql.query<{ scoreboard_service_status: ScoreBoardServiceStatus[] }>(`query ${ServiceStatusQuery($eventId)}`)
    ).scoreboard_service_status;
    serviceDisplayNames = await GetServiceNames($eventId);
    scoreboardTeams = getTeamsFromServiceStatuses();

    const sink = {
      complete: () => console.debug('subscription stopped'),
      error: (err) => console.error(err),
      next: (res: { data: { scoreboard_service_status: Array<ScoreBoardServiceStatus> } }) => {
        scoreBoardServiceStatus = res.data.scoreboard_service_status;

        // If this query returned statuses for more or less teams than are currently in the chart, update the team list
        if (scoreBoardServiceStatus.length !== scoreboardTeams?.length * serviceDisplayNames.length) {
          scoreboardTeams = getTeamsFromServiceStatuses();
        }
      },
    };

    // Get the highest privileged role this user has
    disposeScoresSocket = Gql.subscribe(`subscription ${ServiceStatusQuery($eventId)}`, sink);
  }
</script>

<div class="service-statuses">
  <Table>
    <thead>
      <tr>
        {#if $keycloak.isStaff()}
          <th />
        {/if}
        <th class="px-1">
          <div class="controls">
            <Fa id="serviceStatusHelpButton" class="clickable m-3 text-white" size="3x" icon={faCircleInfo} />
            <Popover class="ms-2" container="body" placement="top" target="serviceStatusHelpButton">
              <div slot="title">Services Legend</div>
              <div class="sv-help-content">
                <p>
                  <Fa size="2x" icon={faArrowCircleUp} class="scoreboard-service-success" />
                  <span class="explain">Service is Scoring</span>
                </p>
                <p>
                  <Fa size="2x" icon={faCircleExclamation} class="scoreboard-service-partial" />
                  <span class="explain">Service is Misconfigured</span>
                </p>
                <p>
                  <Fa size="2x" icon={faArrowCircleDown} class="scoreboard-service-failure" />
                  <span class="explain">Service is unreachable</span>
                </p>
                <p>
                  <Fa size="2x" icon={faArrowCircleDown} class="scoreboard-service-timeout" />
                  <span class="explain">Timeout Exceeded</span>
                </p>
                <p>
                  <Fa size="2x" icon={faCircleQuestion} class="scoreboard-service-unknown" />
                  <span class="explain">Unknown Error, Contact Support</span>
                </p>
              </div>
            </Popover>
          </div>
        </th>
        {#each serviceDisplayNames as dn}
          <th>
            <div class="sq sq-label sq-service">
              {dn.display_name}
            </div>
          </th>
        {/each}
      </tr>
    </thead>
    <tbody>
      {#each scoreboardTeams as t}
        {#if !(t.id in visibleTeams) || visibleTeams[t.id]}
          <tr>
            {#if $keycloak.isStaff()}
              <th class="pe-1">
                <span class="clickable" on:click={() => onHideTeam(t.id)}>
                  <Fa icon={faEyeSlash} />
                </span>
              </th>
            {/if}
            <th scope="row">
              <!-- 300px covers _most_ college names, but we want to set an upper limit -->
              <div style="max-width: 300px;">
                {t.name}
                {#if !shortNames && t.long_name}
                  <p class="my-0">{t.long_name}</p>
                {/if}
              </div>
            </th>
            {#each scoreBoardServiceStatus as status}
              {#if t.name === status.team.name}
                <td style="text-align: center;">
                  <div class="mt-2">
                    <ServiceStatusElement {status} />
                  </div>
                </td>
              {/if}
            {/each}
          </tr>
        {/if}
      {/each}
    </tbody>
  </Table>
</div>

<div class="d-flex mt-4">
  <div class="text-center m-auto alert alert-dark" role="alert">
    View the
    <a href="{$team ? `/teams/${$team.id}/service-feedback` : `/teams`}">
      Service Details page
    </a>
    for more information on why a service might be failing!
  </div>
</div>

<style>
  .controls {
    /* Copied from bootstrap .input-group
     * to avoid straight edges on buttons
     */
    position: relative;
    display: flex;
    flex-wrap: wrap;
    align-items: stretch;
    width: 100%;
  }

  .service-statuses,
  .sq {
    display: flex;
    flex-flow: row nowrap;
    align-content: center;
    justify-content: center;
  }

  .sq {
    flex-flow: column nowrap;
  }

  .sq {
    color: white;
    border: 1px solid #252525;
    font-weight: bold;
    text-align: center;

    min-height: 2.5em;
    min-width: 4em;
  }

  .sq-label {
    border: 0;
    padding: 0 0.4em;
    text-shadow: 1px 1px 10px #888;
  }

  @media (max-width: 768px) {
    /* Transpose services display matrix */
    .service-statuses {
      flex-flow: column wrap;
      display: inline-flex;
      align-content: flex-start;
    }

    /* adjust row sizes, add banding effect, tilt team names upwards */
    .sq {
      font-size: 0.8em;
      min-height: 4em;
    }
  }

  /* Phonies */
  @media (max-width: 450px) {
    .sq {
      font-size: 0.6em;
      min-height: 5em;
    }

    .sq-service {
      font-size: 0.74em;
    }
  }

  .sq-service:first-child {
    /* Remove padding between first service and the table controls */
    padding-left: 0;
  }

  .sv-help-content {
    flex-direction: column;
    align-items: start;

    font-size: 1em;
    padding: 1em;
  }

  .sv-help-content .explain {
    font-size: 1.5em;
    font-weight: 700;
    padding: 0.4em;
  }
</style>
